/**
 * @since 1.0.0
 */
import { type AddTagsToOnPremisesInstancesCommandInput, type AddTagsToOnPremisesInstancesCommandOutput, type BatchGetApplicationRevisionsCommandInput, type BatchGetApplicationRevisionsCommandOutput, type BatchGetApplicationsCommandInput, type BatchGetApplicationsCommandOutput, type BatchGetDeploymentGroupsCommandInput, type BatchGetDeploymentGroupsCommandOutput, type BatchGetDeploymentInstancesCommandInput, type BatchGetDeploymentInstancesCommandOutput, type BatchGetDeploymentsCommandInput, type BatchGetDeploymentsCommandOutput, type BatchGetDeploymentTargetsCommandInput, type BatchGetDeploymentTargetsCommandOutput, type BatchGetOnPremisesInstancesCommandInput, type BatchGetOnPremisesInstancesCommandOutput, type ContinueDeploymentCommandInput, type ContinueDeploymentCommandOutput, type CreateApplicationCommandInput, type CreateApplicationCommandOutput, type CreateDeploymentCommandInput, type CreateDeploymentCommandOutput, type CreateDeploymentConfigCommandInput, type CreateDeploymentConfigCommandOutput, type CreateDeploymentGroupCommandInput, type CreateDeploymentGroupCommandOutput, type DeleteApplicationCommandInput, type DeleteApplicationCommandOutput, type DeleteDeploymentConfigCommandInput, type DeleteDeploymentConfigCommandOutput, type DeleteDeploymentGroupCommandInput, type DeleteDeploymentGroupCommandOutput, type DeleteGitHubAccountTokenCommandInput, type DeleteGitHubAccountTokenCommandOutput, type DeleteResourcesByExternalIdCommandInput, type DeleteResourcesByExternalIdCommandOutput, type DeregisterOnPremisesInstanceCommandInput, type DeregisterOnPremisesInstanceCommandOutput, type GetApplicationCommandInput, type GetApplicationCommandOutput, type GetApplicationRevisionCommandInput, type GetApplicationRevisionCommandOutput, type GetDeploymentCommandInput, type GetDeploymentCommandOutput, type GetDeploymentConfigCommandInput, type GetDeploymentConfigCommandOutput, type GetDeploymentGroupCommandInput, type GetDeploymentGroupCommandOutput, type GetDeploymentInstanceCommandInput, type GetDeploymentInstanceCommandOutput, type GetDeploymentTargetCommandInput, type GetDeploymentTargetCommandOutput, type GetOnPremisesInstanceCommandInput, type GetOnPremisesInstanceCommandOutput, type ListApplicationRevisionsCommandInput, type ListApplicationRevisionsCommandOutput, type ListApplicationsCommandInput, type ListApplicationsCommandOutput, type ListDeploymentConfigsCommandInput, type ListDeploymentConfigsCommandOutput, type ListDeploymentGroupsCommandInput, type ListDeploymentGroupsCommandOutput, type ListDeploymentInstancesCommandInput, type ListDeploymentInstancesCommandOutput, type ListDeploymentsCommandInput, type ListDeploymentsCommandOutput, type ListDeploymentTargetsCommandInput, type ListDeploymentTargetsCommandOutput, type ListGitHubAccountTokenNamesCommandInput, type ListGitHubAccountTokenNamesCommandOutput, type ListOnPremisesInstancesCommandInput, type ListOnPremisesInstancesCommandOutput, type ListTagsForResourceCommandInput, type ListTagsForResourceCommandOutput, type PutLifecycleEventHookExecutionStatusCommandInput, type PutLifecycleEventHookExecutionStatusCommandOutput, type RegisterApplicationRevisionCommandInput, type RegisterApplicationRevisionCommandOutput, type RegisterOnPremisesInstanceCommandInput, type RegisterOnPremisesInstanceCommandOutput, type RemoveTagsFromOnPremisesInstancesCommandInput, type RemoveTagsFromOnPremisesInstancesCommandOutput, type SkipWaitTimeForInstanceTerminationCommandInput, type SkipWaitTimeForInstanceTerminationCommandOutput, type StopDeploymentCommandInput, type StopDeploymentCommandOutput, type TagResourceCommandInput, type TagResourceCommandOutput, type UntagResourceCommandInput, type UntagResourceCommandOutput, type UpdateApplicationCommandInput, type UpdateApplicationCommandOutput, type UpdateDeploymentGroupCommandInput, type UpdateDeploymentGroupCommandOutput } from "@aws-sdk/client-codedeploy";
import { type HttpHandlerOptions as __HttpHandlerOptions } from "@aws-sdk/types";
import { Effect, Layer } from "effect";
import { CodeDeployClientInstance } from "./CodeDeployClientInstance";
import { AlarmsLimitExceededError, ApplicationAlreadyExistsError, ApplicationDoesNotExistError, ApplicationLimitExceededError, ApplicationNameRequiredError, ArnNotSupportedError, BatchLimitExceededError, BucketNameFilterRequiredError, DeploymentAlreadyCompletedError, DeploymentConfigAlreadyExistsError, DeploymentConfigDoesNotExistError, DeploymentConfigInUseError, DeploymentConfigLimitExceededError, DeploymentConfigNameRequiredError, DeploymentDoesNotExistError, DeploymentGroupAlreadyExistsError, DeploymentGroupDoesNotExistError, DeploymentGroupLimitExceededError, DeploymentGroupNameRequiredError, DeploymentIdRequiredError, DeploymentIsNotInReadyStateError, DeploymentLimitExceededError, DeploymentNotStartedError, DeploymentTargetDoesNotExistError, DeploymentTargetIdRequiredError, DeploymentTargetListSizeExceededError, DescriptionTooLongError, ECSServiceMappingLimitExceededError, GitHubAccountTokenDoesNotExistError, GitHubAccountTokenNameRequiredError, IamArnRequiredError, IamSessionArnAlreadyRegisteredError, IamUserArnAlreadyRegisteredError, IamUserArnRequiredError, InstanceDoesNotExistError, InstanceIdRequiredError, InstanceLimitExceededError, InstanceNameAlreadyRegisteredError, InstanceNameRequiredError, InstanceNotRegisteredError, InvalidAlarmConfigError, InvalidApplicationNameError, InvalidArnError, InvalidAutoRollbackConfigError, InvalidAutoScalingGroupError, InvalidBlueGreenDeploymentConfigurationError, InvalidBucketNameFilterError, InvalidComputePlatformError, InvalidDeployedStateFilterError, InvalidDeploymentConfigNameError, InvalidDeploymentGroupNameError, InvalidDeploymentIdError, InvalidDeploymentInstanceTypeError, InvalidDeploymentStatusError, InvalidDeploymentStyleError, InvalidDeploymentTargetIdError, InvalidDeploymentWaitTypeError, InvalidEC2TagCombinationError, InvalidEC2TagError, InvalidECSServiceError, InvalidExternalIdError, InvalidFileExistsBehaviorError, InvalidGitHubAccountTokenError, InvalidGitHubAccountTokenNameError, InvalidIamSessionArnError, InvalidIamUserArnError, InvalidIgnoreApplicationStopFailuresValueError, InvalidInputError, InvalidInstanceNameError, InvalidInstanceStatusError, InvalidInstanceTypeError, InvalidKeyPrefixFilterError, InvalidLifecycleEventHookExecutionIdError, InvalidLifecycleEventHookExecutionStatusError, InvalidLoadBalancerInfoError, InvalidMinimumHealthyHostValueError, InvalidNextTokenError, InvalidOnPremisesTagCombinationError, InvalidOperationError, InvalidRegistrationStatusError, InvalidRevisionError, InvalidRoleError, InvalidSortByError, InvalidSortOrderError, InvalidTagError, InvalidTagFilterError, InvalidTagsToAddError, InvalidTargetFilterNameError, InvalidTargetGroupPairError, InvalidTargetInstancesError, InvalidTimeRangeError, InvalidTrafficRoutingConfigurationError, InvalidTriggerConfigError, InvalidUpdateOutdatedInstancesOnlyValueError, InvalidZonalDeploymentConfigurationError, LifecycleEventAlreadyCompletedError, LifecycleHookLimitExceededError, MultipleIamArnsProvidedError, OperationNotSupportedError, ResourceArnRequiredError, ResourceValidationError, RevisionDoesNotExistError, RevisionRequiredError, RoleRequiredError, TagLimitExceededError, TagRequiredError, TagSetListLimitExceededError, ThrottlingError, TriggerTargetsLimitExceededError, UnsupportedActionForDeploymentTypeError, SdkError } from "./Errors";
interface CodeDeployService$ {
    readonly _: unique symbol;
    /**
     * @see {@link AddTagsToOnPremisesInstancesCommand}
     */
    addTagsToOnPremisesInstances(args: AddTagsToOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<AddTagsToOnPremisesInstancesCommandOutput, SdkError | InstanceLimitExceededError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | InvalidTagError | TagLimitExceededError | TagRequiredError>;
    /**
     * @see {@link BatchGetApplicationRevisionsCommand}
     */
    batchGetApplicationRevisions(args: BatchGetApplicationRevisionsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetApplicationRevisionsCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | InvalidApplicationNameError | InvalidRevisionError | RevisionRequiredError>;
    /**
     * @see {@link BatchGetApplicationsCommand}
     */
    batchGetApplications(args: BatchGetApplicationsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetApplicationsCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | InvalidApplicationNameError>;
    /**
     * @see {@link BatchGetDeploymentGroupsCommand}
     */
    batchGetDeploymentGroups(args: BatchGetDeploymentGroupsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetDeploymentGroupsCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | DeploymentConfigDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError>;
    /**
     * @see {@link BatchGetDeploymentInstancesCommand}
     */
    batchGetDeploymentInstances(args: BatchGetDeploymentInstancesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetDeploymentInstancesCommandOutput, SdkError | BatchLimitExceededError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InstanceIdRequiredError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidInstanceNameError>;
    /**
     * @see {@link BatchGetDeploymentsCommand}
     */
    batchGetDeployments(args: BatchGetDeploymentsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetDeploymentsCommandOutput, SdkError | BatchLimitExceededError | DeploymentIdRequiredError | InvalidDeploymentIdError>;
    /**
     * @see {@link BatchGetDeploymentTargetsCommand}
     */
    batchGetDeploymentTargets(args: BatchGetDeploymentTargetsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetDeploymentTargetsCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | DeploymentTargetDoesNotExistError | DeploymentTargetIdRequiredError | DeploymentTargetListSizeExceededError | InstanceDoesNotExistError | InvalidDeploymentIdError | InvalidDeploymentTargetIdError>;
    /**
     * @see {@link BatchGetOnPremisesInstancesCommand}
     */
    batchGetOnPremisesInstances(args: BatchGetOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<BatchGetOnPremisesInstancesCommandOutput, SdkError | BatchLimitExceededError | InstanceNameRequiredError | InvalidInstanceNameError>;
    /**
     * @see {@link ContinueDeploymentCommand}
     */
    continueDeployment(args: ContinueDeploymentCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ContinueDeploymentCommandOutput, SdkError | DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentIsNotInReadyStateError | InvalidDeploymentIdError | InvalidDeploymentStatusError | InvalidDeploymentWaitTypeError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link CreateApplicationCommand}
     */
    createApplication(args: CreateApplicationCommandInput, options?: __HttpHandlerOptions): Effect.Effect<CreateApplicationCommandOutput, SdkError | ApplicationAlreadyExistsError | ApplicationLimitExceededError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidComputePlatformError | InvalidTagsToAddError>;
    /**
     * @see {@link CreateDeploymentCommand}
     */
    createDeployment(args: CreateDeploymentCommandInput, options?: __HttpHandlerOptions): Effect.Effect<CreateDeploymentCommandOutput, SdkError | AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | DeploymentLimitExceededError | DescriptionTooLongError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidFileExistsBehaviorError | InvalidGitHubAccountTokenError | InvalidIgnoreApplicationStopFailuresValueError | InvalidLoadBalancerInfoError | InvalidRevisionError | InvalidRoleError | InvalidTargetInstancesError | InvalidTrafficRoutingConfigurationError | InvalidUpdateOutdatedInstancesOnlyValueError | RevisionDoesNotExistError | RevisionRequiredError | ThrottlingError>;
    /**
     * @see {@link CreateDeploymentConfigCommand}
     */
    createDeploymentConfig(args: CreateDeploymentConfigCommandInput, options?: __HttpHandlerOptions): Effect.Effect<CreateDeploymentConfigCommandOutput, SdkError | DeploymentConfigAlreadyExistsError | DeploymentConfigLimitExceededError | DeploymentConfigNameRequiredError | InvalidComputePlatformError | InvalidDeploymentConfigNameError | InvalidMinimumHealthyHostValueError | InvalidTrafficRoutingConfigurationError | InvalidZonalDeploymentConfigurationError>;
    /**
     * @see {@link CreateDeploymentGroupCommand}
     */
    createDeploymentGroup(args: CreateDeploymentGroupCommandInput, options?: __HttpHandlerOptions): Effect.Effect<CreateDeploymentGroupCommandOutput, SdkError | AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupAlreadyExistsError | DeploymentGroupLimitExceededError | DeploymentGroupNameRequiredError | ECSServiceMappingLimitExceededError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidBlueGreenDeploymentConfigurationError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStyleError | InvalidEC2TagCombinationError | InvalidEC2TagError | InvalidECSServiceError | InvalidInputError | InvalidLoadBalancerInfoError | InvalidOnPremisesTagCombinationError | InvalidRoleError | InvalidTagError | InvalidTagsToAddError | InvalidTargetGroupPairError | InvalidTrafficRoutingConfigurationError | InvalidTriggerConfigError | LifecycleHookLimitExceededError | RoleRequiredError | TagSetListLimitExceededError | ThrottlingError | TriggerTargetsLimitExceededError>;
    /**
     * @see {@link DeleteApplicationCommand}
     */
    deleteApplication(args: DeleteApplicationCommandInput, options?: __HttpHandlerOptions): Effect.Effect<DeleteApplicationCommandOutput, SdkError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidRoleError>;
    /**
     * @see {@link DeleteDeploymentConfigCommand}
     */
    deleteDeploymentConfig(args: DeleteDeploymentConfigCommandInput, options?: __HttpHandlerOptions): Effect.Effect<DeleteDeploymentConfigCommandOutput, SdkError | DeploymentConfigInUseError | DeploymentConfigNameRequiredError | InvalidDeploymentConfigNameError | InvalidOperationError>;
    /**
     * @see {@link DeleteDeploymentGroupCommand}
     */
    deleteDeploymentGroup(args: DeleteDeploymentGroupCommandInput, options?: __HttpHandlerOptions): Effect.Effect<DeleteDeploymentGroupCommandOutput, SdkError | ApplicationNameRequiredError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | InvalidRoleError>;
    /**
     * @see {@link DeleteGitHubAccountTokenCommand}
     */
    deleteGitHubAccountToken(args: DeleteGitHubAccountTokenCommandInput, options?: __HttpHandlerOptions): Effect.Effect<DeleteGitHubAccountTokenCommandOutput, SdkError | GitHubAccountTokenDoesNotExistError | GitHubAccountTokenNameRequiredError | InvalidGitHubAccountTokenNameError | OperationNotSupportedError | ResourceValidationError>;
    /**
     * @see {@link DeleteResourcesByExternalIdCommand}
     */
    deleteResourcesByExternalId(args: DeleteResourcesByExternalIdCommandInput, options?: __HttpHandlerOptions): Effect.Effect<DeleteResourcesByExternalIdCommandOutput, SdkError>;
    /**
     * @see {@link DeregisterOnPremisesInstanceCommand}
     */
    deregisterOnPremisesInstance(args: DeregisterOnPremisesInstanceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<DeregisterOnPremisesInstanceCommandOutput, SdkError | InstanceNameRequiredError | InvalidInstanceNameError>;
    /**
     * @see {@link GetApplicationCommand}
     */
    getApplication(args: GetApplicationCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetApplicationCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError>;
    /**
     * @see {@link GetApplicationRevisionCommand}
     */
    getApplicationRevision(args: GetApplicationRevisionCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetApplicationRevisionCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidRevisionError | RevisionDoesNotExistError | RevisionRequiredError>;
    /**
     * @see {@link GetDeploymentCommand}
     */
    getDeployment(args: GetDeploymentCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetDeploymentCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError>;
    /**
     * @see {@link GetDeploymentConfigCommand}
     */
    getDeploymentConfig(args: GetDeploymentConfigCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetDeploymentConfigCommandOutput, SdkError | DeploymentConfigDoesNotExistError | DeploymentConfigNameRequiredError | InvalidComputePlatformError | InvalidDeploymentConfigNameError>;
    /**
     * @see {@link GetDeploymentGroupCommand}
     */
    getDeploymentGroup(args: GetDeploymentGroupCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetDeploymentGroupCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError>;
    /**
     * @see {@link GetDeploymentInstanceCommand}
     */
    getDeploymentInstance(args: GetDeploymentInstanceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetDeploymentInstanceCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InstanceDoesNotExistError | InstanceIdRequiredError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidInstanceNameError>;
    /**
     * @see {@link GetDeploymentTargetCommand}
     */
    getDeploymentTarget(args: GetDeploymentTargetCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetDeploymentTargetCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | DeploymentTargetDoesNotExistError | DeploymentTargetIdRequiredError | InvalidDeploymentIdError | InvalidDeploymentTargetIdError | InvalidInstanceNameError>;
    /**
     * @see {@link GetOnPremisesInstanceCommand}
     */
    getOnPremisesInstance(args: GetOnPremisesInstanceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<GetOnPremisesInstanceCommandOutput, SdkError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError>;
    /**
     * @see {@link ListApplicationRevisionsCommand}
     */
    listApplicationRevisions(args: ListApplicationRevisionsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListApplicationRevisionsCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | BucketNameFilterRequiredError | InvalidApplicationNameError | InvalidBucketNameFilterError | InvalidDeployedStateFilterError | InvalidKeyPrefixFilterError | InvalidNextTokenError | InvalidSortByError | InvalidSortOrderError>;
    /**
     * @see {@link ListApplicationsCommand}
     */
    listApplications(args: ListApplicationsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListApplicationsCommandOutput, SdkError | InvalidNextTokenError>;
    /**
     * @see {@link ListDeploymentConfigsCommand}
     */
    listDeploymentConfigs(args: ListDeploymentConfigsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListDeploymentConfigsCommandOutput, SdkError | InvalidNextTokenError>;
    /**
     * @see {@link ListDeploymentGroupsCommand}
     */
    listDeploymentGroups(args: ListDeploymentGroupsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListDeploymentGroupsCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidNextTokenError>;
    /**
     * @see {@link ListDeploymentInstancesCommand}
     */
    listDeploymentInstances(args: ListDeploymentInstancesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListDeploymentInstancesCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidDeploymentInstanceTypeError | InvalidInstanceStatusError | InvalidInstanceTypeError | InvalidNextTokenError | InvalidTargetFilterNameError>;
    /**
     * @see {@link ListDeploymentsCommand}
     */
    listDeployments(args: ListDeploymentsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListDeploymentsCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStatusError | InvalidExternalIdError | InvalidInputError | InvalidNextTokenError | InvalidTimeRangeError>;
    /**
     * @see {@link ListDeploymentTargetsCommand}
     */
    listDeploymentTargets(args: ListDeploymentTargetsCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListDeploymentTargetsCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidDeploymentIdError | InvalidDeploymentInstanceTypeError | InvalidInstanceStatusError | InvalidInstanceTypeError | InvalidNextTokenError | InvalidTargetFilterNameError>;
    /**
     * @see {@link ListGitHubAccountTokenNamesCommand}
     */
    listGitHubAccountTokenNames(args: ListGitHubAccountTokenNamesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListGitHubAccountTokenNamesCommandOutput, SdkError | InvalidNextTokenError | OperationNotSupportedError | ResourceValidationError>;
    /**
     * @see {@link ListOnPremisesInstancesCommand}
     */
    listOnPremisesInstances(args: ListOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListOnPremisesInstancesCommandOutput, SdkError | InvalidNextTokenError | InvalidRegistrationStatusError | InvalidTagFilterError>;
    /**
     * @see {@link ListTagsForResourceCommand}
     */
    listTagsForResource(args: ListTagsForResourceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<ListTagsForResourceCommandOutput, SdkError | ArnNotSupportedError | InvalidArnError | ResourceArnRequiredError>;
    /**
     * @see {@link PutLifecycleEventHookExecutionStatusCommand}
     */
    putLifecycleEventHookExecutionStatus(args: PutLifecycleEventHookExecutionStatusCommandInput, options?: __HttpHandlerOptions): Effect.Effect<PutLifecycleEventHookExecutionStatusCommandOutput, SdkError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | InvalidLifecycleEventHookExecutionIdError | InvalidLifecycleEventHookExecutionStatusError | LifecycleEventAlreadyCompletedError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link RegisterApplicationRevisionCommand}
     */
    registerApplicationRevision(args: RegisterApplicationRevisionCommandInput, options?: __HttpHandlerOptions): Effect.Effect<RegisterApplicationRevisionCommandOutput, SdkError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DescriptionTooLongError | InvalidApplicationNameError | InvalidRevisionError | RevisionRequiredError>;
    /**
     * @see {@link RegisterOnPremisesInstanceCommand}
     */
    registerOnPremisesInstance(args: RegisterOnPremisesInstanceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<RegisterOnPremisesInstanceCommandOutput, SdkError | IamArnRequiredError | IamSessionArnAlreadyRegisteredError | IamUserArnAlreadyRegisteredError | IamUserArnRequiredError | InstanceNameAlreadyRegisteredError | InstanceNameRequiredError | InvalidIamSessionArnError | InvalidIamUserArnError | InvalidInstanceNameError | MultipleIamArnsProvidedError>;
    /**
     * @see {@link RemoveTagsFromOnPremisesInstancesCommand}
     */
    removeTagsFromOnPremisesInstances(args: RemoveTagsFromOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions): Effect.Effect<RemoveTagsFromOnPremisesInstancesCommandOutput, SdkError | InstanceLimitExceededError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | InvalidTagError | TagLimitExceededError | TagRequiredError>;
    /**
     * @see {@link SkipWaitTimeForInstanceTerminationCommand}
     */
    skipWaitTimeForInstanceTermination(args: SkipWaitTimeForInstanceTerminationCommandInput, options?: __HttpHandlerOptions): Effect.Effect<SkipWaitTimeForInstanceTerminationCommandOutput, SdkError | DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidDeploymentIdError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link StopDeploymentCommand}
     */
    stopDeployment(args: StopDeploymentCommandInput, options?: __HttpHandlerOptions): Effect.Effect<StopDeploymentCommandOutput, SdkError | DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | UnsupportedActionForDeploymentTypeError>;
    /**
     * @see {@link TagResourceCommand}
     */
    tagResource(args: TagResourceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<TagResourceCommandOutput, SdkError | ApplicationDoesNotExistError | ArnNotSupportedError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | InvalidArnError | InvalidTagsToAddError | ResourceArnRequiredError | TagRequiredError>;
    /**
     * @see {@link UntagResourceCommand}
     */
    untagResource(args: UntagResourceCommandInput, options?: __HttpHandlerOptions): Effect.Effect<UntagResourceCommandOutput, SdkError | ApplicationDoesNotExistError | ArnNotSupportedError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | InvalidArnError | InvalidTagsToAddError | ResourceArnRequiredError | TagRequiredError>;
    /**
     * @see {@link UpdateApplicationCommand}
     */
    updateApplication(args: UpdateApplicationCommandInput, options?: __HttpHandlerOptions): Effect.Effect<UpdateApplicationCommandOutput, SdkError | ApplicationAlreadyExistsError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError>;
    /**
     * @see {@link UpdateDeploymentGroupCommand}
     */
    updateDeploymentGroup(args: UpdateDeploymentGroupCommandInput, options?: __HttpHandlerOptions): Effect.Effect<UpdateDeploymentGroupCommandOutput, SdkError | AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupAlreadyExistsError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | ECSServiceMappingLimitExceededError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidBlueGreenDeploymentConfigurationError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStyleError | InvalidEC2TagCombinationError | InvalidEC2TagError | InvalidECSServiceError | InvalidInputError | InvalidLoadBalancerInfoError | InvalidOnPremisesTagCombinationError | InvalidRoleError | InvalidTagError | InvalidTargetGroupPairError | InvalidTrafficRoutingConfigurationError | InvalidTriggerConfigError | LifecycleHookLimitExceededError | TagSetListLimitExceededError | ThrottlingError | TriggerTargetsLimitExceededError>;
}
declare const CodeDeployService_base: import("effect/Context").TagClass<CodeDeployService, "@effect-aws/client-codedeploy/CodeDeployService", CodeDeployService$> & {
    readonly _: Effect.Effect<CodeDeployService$["_"], never, CodeDeployService>;
    addTagsToOnPremisesInstances: (args: AddTagsToOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<AddTagsToOnPremisesInstancesCommandOutput, InstanceLimitExceededError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | InvalidTagError | TagLimitExceededError | TagRequiredError | SdkError, CodeDeployService>;
    batchGetApplicationRevisions: (args: BatchGetApplicationRevisionsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetApplicationRevisionsCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | InvalidApplicationNameError | InvalidRevisionError | RevisionRequiredError | SdkError, CodeDeployService>;
    batchGetApplications: (args: BatchGetApplicationsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetApplicationsCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | InvalidApplicationNameError | SdkError, CodeDeployService>;
    batchGetDeploymentGroups: (args: BatchGetDeploymentGroupsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetDeploymentGroupsCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | BatchLimitExceededError | DeploymentConfigDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | SdkError, CodeDeployService>;
    batchGetDeploymentInstances: (args: BatchGetDeploymentInstancesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetDeploymentInstancesCommandOutput, BatchLimitExceededError | DeploymentDoesNotExistError | DeploymentIdRequiredError | InstanceIdRequiredError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidInstanceNameError | SdkError, CodeDeployService>;
    batchGetDeployments: (args: BatchGetDeploymentsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetDeploymentsCommandOutput, BatchLimitExceededError | DeploymentIdRequiredError | InvalidDeploymentIdError | SdkError, CodeDeployService>;
    batchGetDeploymentTargets: (args: BatchGetDeploymentTargetsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetDeploymentTargetsCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | DeploymentTargetDoesNotExistError | DeploymentTargetIdRequiredError | DeploymentTargetListSizeExceededError | InstanceDoesNotExistError | InvalidDeploymentIdError | InvalidDeploymentTargetIdError | SdkError, CodeDeployService>;
    batchGetOnPremisesInstances: (args: BatchGetOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<BatchGetOnPremisesInstancesCommandOutput, BatchLimitExceededError | InstanceNameRequiredError | InvalidInstanceNameError | SdkError, CodeDeployService>;
    continueDeployment: (args: ContinueDeploymentCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ContinueDeploymentCommandOutput, DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentIsNotInReadyStateError | InvalidDeploymentIdError | InvalidDeploymentStatusError | InvalidDeploymentWaitTypeError | UnsupportedActionForDeploymentTypeError | SdkError, CodeDeployService>;
    createApplication: (args: CreateApplicationCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<CreateApplicationCommandOutput, ApplicationAlreadyExistsError | ApplicationLimitExceededError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidComputePlatformError | InvalidTagsToAddError | SdkError, CodeDeployService>;
    createDeployment: (args: CreateDeploymentCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<CreateDeploymentCommandOutput, AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | DeploymentLimitExceededError | DescriptionTooLongError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidFileExistsBehaviorError | InvalidGitHubAccountTokenError | InvalidIgnoreApplicationStopFailuresValueError | InvalidLoadBalancerInfoError | InvalidRevisionError | InvalidRoleError | InvalidTargetInstancesError | InvalidTrafficRoutingConfigurationError | InvalidUpdateOutdatedInstancesOnlyValueError | RevisionDoesNotExistError | RevisionRequiredError | ThrottlingError | SdkError, CodeDeployService>;
    createDeploymentConfig: (args: CreateDeploymentConfigCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<CreateDeploymentConfigCommandOutput, DeploymentConfigAlreadyExistsError | DeploymentConfigLimitExceededError | DeploymentConfigNameRequiredError | InvalidComputePlatformError | InvalidDeploymentConfigNameError | InvalidMinimumHealthyHostValueError | InvalidTrafficRoutingConfigurationError | InvalidZonalDeploymentConfigurationError | SdkError, CodeDeployService>;
    createDeploymentGroup: (args: CreateDeploymentGroupCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<CreateDeploymentGroupCommandOutput, AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupAlreadyExistsError | DeploymentGroupLimitExceededError | DeploymentGroupNameRequiredError | ECSServiceMappingLimitExceededError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidBlueGreenDeploymentConfigurationError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStyleError | InvalidEC2TagCombinationError | InvalidEC2TagError | InvalidECSServiceError | InvalidInputError | InvalidLoadBalancerInfoError | InvalidOnPremisesTagCombinationError | InvalidRoleError | InvalidTagError | InvalidTagsToAddError | InvalidTargetGroupPairError | InvalidTrafficRoutingConfigurationError | InvalidTriggerConfigError | LifecycleHookLimitExceededError | RoleRequiredError | TagSetListLimitExceededError | ThrottlingError | TriggerTargetsLimitExceededError | SdkError, CodeDeployService>;
    deleteApplication: (args: DeleteApplicationCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<DeleteApplicationCommandOutput, ApplicationNameRequiredError | InvalidApplicationNameError | InvalidRoleError | SdkError, CodeDeployService>;
    deleteDeploymentConfig: (args: DeleteDeploymentConfigCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<DeleteDeploymentConfigCommandOutput, DeploymentConfigInUseError | DeploymentConfigNameRequiredError | InvalidDeploymentConfigNameError | InvalidOperationError | SdkError, CodeDeployService>;
    deleteDeploymentGroup: (args: DeleteDeploymentGroupCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<DeleteDeploymentGroupCommandOutput, ApplicationNameRequiredError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | InvalidRoleError | SdkError, CodeDeployService>;
    deleteGitHubAccountToken: (args: DeleteGitHubAccountTokenCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<DeleteGitHubAccountTokenCommandOutput, GitHubAccountTokenDoesNotExistError | GitHubAccountTokenNameRequiredError | InvalidGitHubAccountTokenNameError | OperationNotSupportedError | ResourceValidationError | SdkError, CodeDeployService>;
    deleteResourcesByExternalId: (args: DeleteResourcesByExternalIdCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<DeleteResourcesByExternalIdCommandOutput, SdkError, CodeDeployService>;
    deregisterOnPremisesInstance: (args: DeregisterOnPremisesInstanceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<DeregisterOnPremisesInstanceCommandOutput, InstanceNameRequiredError | InvalidInstanceNameError | SdkError, CodeDeployService>;
    getApplication: (args: GetApplicationCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetApplicationCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | SdkError, CodeDeployService>;
    getApplicationRevision: (args: GetApplicationRevisionCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetApplicationRevisionCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidRevisionError | RevisionDoesNotExistError | RevisionRequiredError | SdkError, CodeDeployService>;
    getDeployment: (args: GetDeploymentCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetDeploymentCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | SdkError, CodeDeployService>;
    getDeploymentConfig: (args: GetDeploymentConfigCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetDeploymentConfigCommandOutput, DeploymentConfigDoesNotExistError | DeploymentConfigNameRequiredError | InvalidComputePlatformError | InvalidDeploymentConfigNameError | SdkError, CodeDeployService>;
    getDeploymentGroup: (args: GetDeploymentGroupCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetDeploymentGroupCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | SdkError, CodeDeployService>;
    getDeploymentInstance: (args: GetDeploymentInstanceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetDeploymentInstanceCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | InstanceDoesNotExistError | InstanceIdRequiredError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidInstanceNameError | SdkError, CodeDeployService>;
    getDeploymentTarget: (args: GetDeploymentTargetCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetDeploymentTargetCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | DeploymentTargetDoesNotExistError | DeploymentTargetIdRequiredError | InvalidDeploymentIdError | InvalidDeploymentTargetIdError | InvalidInstanceNameError | SdkError, CodeDeployService>;
    getOnPremisesInstance: (args: GetOnPremisesInstanceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<GetOnPremisesInstanceCommandOutput, InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | SdkError, CodeDeployService>;
    listApplicationRevisions: (args: ListApplicationRevisionsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListApplicationRevisionsCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | BucketNameFilterRequiredError | InvalidApplicationNameError | InvalidBucketNameFilterError | InvalidDeployedStateFilterError | InvalidKeyPrefixFilterError | InvalidNextTokenError | InvalidSortByError | InvalidSortOrderError | SdkError, CodeDeployService>;
    listApplications: (args: ListApplicationsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListApplicationsCommandOutput, InvalidNextTokenError | SdkError, CodeDeployService>;
    listDeploymentConfigs: (args: ListDeploymentConfigsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListDeploymentConfigsCommandOutput, InvalidNextTokenError | SdkError, CodeDeployService>;
    listDeploymentGroups: (args: ListDeploymentGroupsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListDeploymentGroupsCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | InvalidNextTokenError | SdkError, CodeDeployService>;
    listDeploymentInstances: (args: ListDeploymentInstancesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListDeploymentInstancesCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidComputePlatformError | InvalidDeploymentIdError | InvalidDeploymentInstanceTypeError | InvalidInstanceStatusError | InvalidInstanceTypeError | InvalidNextTokenError | InvalidTargetFilterNameError | SdkError, CodeDeployService>;
    listDeployments: (args: ListDeploymentsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListDeploymentsCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | InvalidApplicationNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStatusError | InvalidExternalIdError | InvalidInputError | InvalidNextTokenError | InvalidTimeRangeError | SdkError, CodeDeployService>;
    listDeploymentTargets: (args: ListDeploymentTargetsCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListDeploymentTargetsCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidDeploymentIdError | InvalidDeploymentInstanceTypeError | InvalidInstanceStatusError | InvalidInstanceTypeError | InvalidNextTokenError | InvalidTargetFilterNameError | SdkError, CodeDeployService>;
    listGitHubAccountTokenNames: (args: ListGitHubAccountTokenNamesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListGitHubAccountTokenNamesCommandOutput, InvalidNextTokenError | OperationNotSupportedError | ResourceValidationError | SdkError, CodeDeployService>;
    listOnPremisesInstances: (args: ListOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListOnPremisesInstancesCommandOutput, InvalidNextTokenError | InvalidRegistrationStatusError | InvalidTagFilterError | SdkError, CodeDeployService>;
    listTagsForResource: (args: ListTagsForResourceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<ListTagsForResourceCommandOutput, ArnNotSupportedError | InvalidArnError | ResourceArnRequiredError | SdkError, CodeDeployService>;
    putLifecycleEventHookExecutionStatus: (args: PutLifecycleEventHookExecutionStatusCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<PutLifecycleEventHookExecutionStatusCommandOutput, DeploymentDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | InvalidLifecycleEventHookExecutionIdError | InvalidLifecycleEventHookExecutionStatusError | LifecycleEventAlreadyCompletedError | UnsupportedActionForDeploymentTypeError | SdkError, CodeDeployService>;
    registerApplicationRevision: (args: RegisterApplicationRevisionCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<RegisterApplicationRevisionCommandOutput, ApplicationDoesNotExistError | ApplicationNameRequiredError | DescriptionTooLongError | InvalidApplicationNameError | InvalidRevisionError | RevisionRequiredError | SdkError, CodeDeployService>;
    registerOnPremisesInstance: (args: RegisterOnPremisesInstanceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<RegisterOnPremisesInstanceCommandOutput, IamArnRequiredError | IamSessionArnAlreadyRegisteredError | IamUserArnAlreadyRegisteredError | IamUserArnRequiredError | InstanceNameAlreadyRegisteredError | InstanceNameRequiredError | InvalidIamSessionArnError | InvalidIamUserArnError | InvalidInstanceNameError | MultipleIamArnsProvidedError | SdkError, CodeDeployService>;
    removeTagsFromOnPremisesInstances: (args: RemoveTagsFromOnPremisesInstancesCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<RemoveTagsFromOnPremisesInstancesCommandOutput, InstanceLimitExceededError | InstanceNameRequiredError | InstanceNotRegisteredError | InvalidInstanceNameError | InvalidTagError | TagLimitExceededError | TagRequiredError | SdkError, CodeDeployService>;
    skipWaitTimeForInstanceTermination: (args: SkipWaitTimeForInstanceTerminationCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<SkipWaitTimeForInstanceTerminationCommandOutput, DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentIdRequiredError | DeploymentNotStartedError | InvalidDeploymentIdError | UnsupportedActionForDeploymentTypeError | SdkError, CodeDeployService>;
    stopDeployment: (args: StopDeploymentCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<StopDeploymentCommandOutput, DeploymentAlreadyCompletedError | DeploymentDoesNotExistError | DeploymentGroupDoesNotExistError | DeploymentIdRequiredError | InvalidDeploymentIdError | UnsupportedActionForDeploymentTypeError | SdkError, CodeDeployService>;
    tagResource: (args: TagResourceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<TagResourceCommandOutput, ApplicationDoesNotExistError | ArnNotSupportedError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | InvalidArnError | InvalidTagsToAddError | ResourceArnRequiredError | TagRequiredError | SdkError, CodeDeployService>;
    untagResource: (args: UntagResourceCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<UntagResourceCommandOutput, ApplicationDoesNotExistError | ArnNotSupportedError | DeploymentConfigDoesNotExistError | DeploymentGroupDoesNotExistError | InvalidArnError | InvalidTagsToAddError | ResourceArnRequiredError | TagRequiredError | SdkError, CodeDeployService>;
    updateApplication: (args: UpdateApplicationCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<UpdateApplicationCommandOutput, ApplicationAlreadyExistsError | ApplicationDoesNotExistError | ApplicationNameRequiredError | InvalidApplicationNameError | SdkError, CodeDeployService>;
    updateDeploymentGroup: (args: UpdateDeploymentGroupCommandInput, options?: __HttpHandlerOptions | undefined) => Effect.Effect<UpdateDeploymentGroupCommandOutput, AlarmsLimitExceededError | ApplicationDoesNotExistError | ApplicationNameRequiredError | DeploymentConfigDoesNotExistError | DeploymentGroupAlreadyExistsError | DeploymentGroupDoesNotExistError | DeploymentGroupNameRequiredError | ECSServiceMappingLimitExceededError | InvalidAlarmConfigError | InvalidApplicationNameError | InvalidAutoRollbackConfigError | InvalidAutoScalingGroupError | InvalidBlueGreenDeploymentConfigurationError | InvalidDeploymentConfigNameError | InvalidDeploymentGroupNameError | InvalidDeploymentStyleError | InvalidEC2TagCombinationError | InvalidEC2TagError | InvalidECSServiceError | InvalidInputError | InvalidLoadBalancerInfoError | InvalidOnPremisesTagCombinationError | InvalidRoleError | InvalidTagError | InvalidTargetGroupPairError | InvalidTrafficRoutingConfigurationError | InvalidTriggerConfigError | LifecycleHookLimitExceededError | TagSetListLimitExceededError | ThrottlingError | TriggerTargetsLimitExceededError | SdkError, CodeDeployService>;
} & {
    use: <X>(body: (_: CodeDeployService$) => X) => X extends Effect.Effect<infer A, infer E, infer R> ? Effect.Effect<A, E, R | CodeDeployService> : Effect.Effect<X, never, CodeDeployService>;
};
/**
 * @since 1.0.0
 * @category models
 */
export declare class CodeDeployService extends CodeDeployService_base {
}
/**
 * @since 1.0.0
 * @category constructors
 */
export declare const makeCodeDeployService: Effect.Effect<CodeDeployService$, never, CodeDeployClientInstance>;
/**
 * @since 1.0.0
 * @category layers
 */
export declare const BaseCodeDeployServiceLayer: Layer.Layer<CodeDeployService, never, CodeDeployClientInstance>;
/**
 * @since 1.0.0
 * @category layers
 */
export declare const CodeDeployServiceLayer: Layer.Layer<CodeDeployService, never, import("./CodeDeployClientInstanceConfig").CodeDeployClientInstanceConfig>;
/**
 * @since 1.0.0
 * @category layers
 */
export declare const DefaultCodeDeployServiceLayer: Layer.Layer<CodeDeployService, never, never>;
export {};
